#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
package ${package}.web.infra;

/**
 * この列挙型は、画面のモードを表すVOです。
 * モードごとに識別子が定義されます。
 *
 * @author SIToolkit
 *
 */
public enum PageMode {
	/**
	 * 作成モード
	 */
	create, 
	/**
	 * 更新モード
	 */ update;

	/**
	 * 作成モードである場合にtrueを返します。
	 * @return 作成モードである場合にtrue
	 */
	public boolean isCreate() {
		return create.equals(this);
	}

	/**
	 * 更新モードである場合にtrueを返します。
	 * @return 更新モードである場合にtrue
	 */
	public boolean isUpdate() {
		return update.equals(this);
	}

	public boolean isAny() {
		return true;
	}
	
}
