#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
package ${package}.web.infra;

import java.io.Serializable;
import javax.enterprise.inject.Produces;
import javax.enterprise.inject.spi.InjectionPoint;

/**
 * このクラスは、{@link RequestParam}のプロデューサです。
 *
 * @author SIToolkit
 * @see http://docs.jboss.org/seam/3/solder/latest/reference/en-US/html/injectablerefs.html
 */
public class RequestParamProducer implements Serializable {

	/**
	 * @RequestParamのvalueまたは宣言されたメンバ名をキーに、
	 * リクエストパラメータを取得します。
	 * 
	 * @param ip @RequestParamが宣言された箇所
	 * @return 送信されたリクエストパラメータ
	 */
	@Produces
	@RequestParam
	String getRequestParameter(InjectionPoint ip) {
		String name = ip.getAnnotated().getAnnotation(RequestParam.class).value();

		if ("".equals(name)) {
			name = ip.getMember().getName();
		}

		return JSFUtils.req().getParameter(name);
	}
}
