@echo off

for /F "usebackq" %%i in (`dir /B /ON C:\PROGRA~1\java\jdk*`) do @set JAVA_HOME=C:\PROGRA~1\java\%%i
set DERBY_ROOT=%DB_HOME%
set PATH=%PATH%;%JAVA_HOME%\bin
set DERBY_RUN=%DERBY_ROOT%\lib\derbyrun.jar
set DERBY_CLASSPATH=%DERBY_ROOT%\lib\derbytools.jar;%DERBY_ROOT%\lib\derby.jar;%DERBY_ROOT%\lib\derbynet.jar;%DERBY_ROOT%\lib\derbyclient.jar
set DERBY_HOME=%DERBY_ROOT%\data
set JAVA_OPTS=-Dderby.system.home="%DERBY_HOME%" ^
	-Dij.database=jdbc:derby://%DB_HOST%:%DB_PORT%/%DB%;create=true;user=%APP_USER%;password=%APP_USER_PASS% ^
	-Dij.outfile="%LOG_FILE%"
set SCRIPT_FILE=%~dp0script\%1.sql
set LOG_FILE=%~dp0log\%1.log

if exist "%SCRIPT_FILE%" (
	del "%SCRIPT_FILE%"
)

if exist "%LOG_FILE%" (
	del "%LOG_FILE%"
)

call :%1

set ERR=%ERRORLEVEL%

if defined NO_SCRIPT (
	goto :end
)

if exist derby.log (
	del derby.log
)

call :log XNvgs܂B
call :log %SCRIPT_FILE%

java %JAVA_OPTS% -classpath "%DERBY_CLASSPATH%" org.apache.derby.tools.ij "%SCRIPT_FILE%"

if %ERR%==0 (
	call :log R}h%1ɏI܂B
) else (
	call :log R}h%1ُI܂B
)

:end
if exist "%~dp0pause.txt" pause

exit /B %ERR%

REM 
REM 
REM 
REM Tu[`Fsetup-db
REM 
:setup-db
start java %JAVA_OPTS% -jar "%DERBY_RUN%" server start -p %DB_PORT%
set NO_SCRIPT=1
exit /B 0
REM 
REM 
REM 
REM Tu[`Fstart-server
REM 
:start-server
java %JAVA_OPTS% -jar "%DERBY_RUN%" server start -p %DB_PORT%
set NO_SCRIPT=1
exit /B 0
REM 
REM 
REM 
REM Tu[`Fstop-server
REM 
:stop-server
java %JAVA_OPTS% -jar "%DERBY_RUN%" server shutdown -p %DB_PORT%
set NO_SCRIPT=1
exit /B 0
REM 
REM 
REM 
REM Tu[`Fcreate-objects
REM 
:create-objects
for /F "usebackq" %%i in (`dir /B /ON script\tb*`) do (
	echo RUN 'script/%%i'; >> "%SCRIPT_FILE%"
)
echo SHOW TABLES IN %APP_USER% >> "%SCRIPT_FILE%"
exit/B
REM 
REM 
REM 
REM Tu[`Fimport-master-data
REM 
:import-master-data
for /F "usebackq" %%i in (`dir /B /ON script\tbm*`) do (
	call :retrive-tbl %%i
	echo CALL SYSCS_UTIL.SYSCS_IMPORT_DATA ^(null, '!TBL!', null, null, 'data/!TBL!.csv', ',', '^"', 'MS932', 0^);  >> "%SCRIPT_FILE%"
	echo SELECT COUNT^(1^) AS !TBL! FROM !TBL!; >> "%SCRIPT_FILE%"
)

exit /B
REM 
REM 
REM 
REM Tu[`Fdelete-master-data
REM 
:delete-master-data
for /F "usebackq" %%i in (`dir /B /O-N script\tbm*`) do (
	call :retrive-tbl %%i
	echo DELETE FROM !TBL!; >> "%SCRIPT_FILE%"
	echo SELECT COUNT^(1^) AS !TBL! FROM !TBL!; >> "%SCRIPT_FILE%"
)
exit /B
REM 
REM 
REM 
REM Tu[`Fdrop-objects
REM 
:drop-objects
for /F "usebackq" %%i in (`dir /B /O-N script\tb*`) do (
	call :retrive-tbl %%i
	echo drop table !TBL!; >> "%SCRIPT_FILE%"
)
echo SHOW TABLES IN %APP_USER% >> "%SCRIPT_FILE%"
exit /B
REM 
REM 
REM 
REM Tu[`Fteardown-db
REM 
:teardown-db
set NO_SCRIPT=1
echo %DERBY_HOME%폜܂B
rd /S /Q "%DERBY_HOME%"
exit /B %ERRORLEVEL%
REM 
REM 
REM 
REM Tu[`Fretrive-tbl
REM 
:retrive-tbl
set FL=%1
set TBL=%FL:.sql=%
set TBL=%TBL:~13%
for %%i in (A B C D E F G H I J K L M N O P Q R S T U V W X Y Z) do call set TBL=%%TBL:%%i=%%i%%
exit /B


:log
echo ** %1
exit /B
